var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
} 

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    drawIntroImage();
    drawLogoImage();
    if (IntroStep<IntroLastStep) drawButtonNext();
    if (IntroStep>1) drawButtonBack();
    if (IntroStep==IntroLastStep){
        $("#controlsDiv").show();
        imgToShowHeight=parseInt(Math.min(imgToShow.height,BottomPanelTop-imgToShowTop-140));
        imgToShowWidth=parseInt(imgToShow.width*imgToShowHeight/imgToShow.height);
        cntx.drawImage(imgToShow,imgToShowLeft,imgToShowTop,imgToShowWidth,imgToShowHeight);
        cntx.strokeStyle="rgb(0,0,0)";
        cntx.beginPath();
        cntx.rect(imgToShowLeft,imgToShowTop,imgToShowWidth,imgToShowHeight);
        cntx.stroke();
        MakeASCIIArt();
    }
    else{
        $("#controlsDiv").hide();
    }
    showUserPrompts();
}

function drawIntroImage(){
    Intro=document.getElementById("img"+IntroStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && IntroStep<IntroLastStep) {
        IntroStep++;
        if(IntroStep==IntroLastStep){
            LoadPicToShow();
        }
        drawBasicScreen();
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && IntroStep>1) {
        IntroStep--;
        drawBasicScreen();
    }
}

function showUserPrompts(){
    var vTxtOffset=15;
    var promptYCoord;
    promptYCoord=BottomPanelTop+15;
    if(IntroStep==IntroLastStep){
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Χρησιμοποίησε τη μπάρα κύλησης [Λεπτομέρεια] για να αλλάξεις τη λεπτομέρεια της εικόνας.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Χρησιμοποίησε την μπάρα κύλησης [Απόσταση] για να δεις τα σύμβολα που σχηματίζουν την εικόνα.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Δοκίμασε διαδοχικά τις επιλογές [Ασπρόμαυρο], [Κλίμακα του γκρι] και [Χρώμα].");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Φόρτωσε μια διαφορετική εικόνα πατώντας το κουμπί [Αλλαγή εικόνας].");
    }
}

function MakeASCIIArt(){
	var imageData=cntx.getImageData(imgToShowLeft,imgToShowTop,imgToShowWidth,imgToShowHeight);
    var LetterColor="rgb(0,0,0)";
    var ToPrint;
    var x,y,CX,CY,h,w,StartX,StartY,Brightness,CurrentX,CurrentY;
    var r=0,g=0,b=0,Grey=0,SB,CharOffset;
    var Xstep=parseInt($("#HscrScale").prop("max"))+1-parseInt($("#HscrScale").val());
    var Ystep=2*Xstep;
    var PixelsInCalculations;
    CharOffset=parseInt($("#HScrCharDistance").val());
    for(h=0;h<imgToShowHeight/Ystep;h++){
        StartY=h*Ystep;
        ToPrint="";
        CurrentX=5;
        CurrentY=imgToShowTop+imgToShowHeight+10+(h+1)*CharOffset;
        if(CurrentY<BottomPanelTop){
            for(w=0;w<=imgToShowWidth/Xstep;w++){
                StartX=w*Xstep;
                Brightness=0;
                PixelsInCalculations=0;
                for(y=0;y<Ystep;y++){
                    for(x=0;x<Xstep;x++){
                        CY=y+StartY;
                        CX=x+StartX;
                        if(CX<imgToShowWidth && CY<imgToShowHeight){
                        	var pointIndx=4*(CX+CY*imgToShowWidth);
                        	r=imageData.data[pointIndx];
                        	g=imageData.data[pointIndx+1];
                        	b=imageData.data[pointIndx+2];
                            Grey=parseInt((r+g+b)/3);
                            PixelsInCalculations++;
                        }
                        Brightness=Brightness+Grey;
                    }
                }
                var slctdRadioBtn=$('input[type=radio][name=colorStyle]:checked').attr('id');
                if(slctdRadioBtn=="bw"){
                    if(PixelsInCalculations>0){
                        SB=parseInt(Brightness*100/(255*PixelsInCalculations));
                    }
                    else {
                        SB=Brightness;
                    }
                }
                else{
                    SB=parseInt(Brightness/100);
                }
                ToPrint=ToPrint+ConvertToASCII(SB);
                if(slctdRadioBtn=="bw"){
                    LetterColor="rgb(0,0,0)";
                }
                else if(slctdRadioBtn=="greyScale"){
                    LetterColor="rgb("+Grey+","+Grey+","+Grey+")";
                }
                else if(slctdRadioBtn=="color"){
                    LetterColor="rgb("+r+","+g+","+b+")";
                }
                cnvsWrite(LetterColor,14,"Arial",CurrentX,CurrentY,ToPrint);
                CurrentX=CurrentX+CharOffset/2;
                ToPrint="";
            }
        }
    }
}

function ConvertToASCII(SB){
    var asc;
    if(SB<25){
        asc="#";
    }
    else if(SB<30){
        asc="@";
    }
    else if(SB<40) {
        asc="?";
    }
    else if(SB<45) {
        asc="$";
    }
    else if(SB<50) {
        asc="&";
    }
    else if(SB<55) {
        asc="¤";
    }
    else if(SB<60) {
        asc="~";
    }
    else if(SB<60) {
        asc="·";
    }
    else if(SB<70) {
        asc="¨";
    }
    else if(SB<80) {
        asc="?";
    }
    else {
        asc=" ";
    }
    return asc;
}

function LoadPicToShow(){
    var i=parseInt(Math.random()*47)+1;
    imgToShow=document.getElementById("s"+i);
}

function changePicture(){
	LoadPicToShow();
	drawBasicScreen();
}